# json-config-read

# install:

```sh
npm i --save json-config-read
```

# API

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [ConfigReadOptions](#configreadoptions)
    -   [Parameters](#parameters)
    -   [allowDirectories](#allowdirectories)
    -   [rootPath](#rootpath)
    -   [extensions](#extensions)
    -   [default](#default)
-   [configReadSync](#configreadsync)
    -   [Parameters](#parameters-1)
-   [configReadAsync](#configreadasync)
    -   [Parameters](#parameters-2)
-   [configsListAsync](#configslistasync)
    -   [Parameters](#parameters-3)
-   [configsListSync](#configslistsync)
    -   [Parameters](#parameters-4)
-   [configsReadManyAsync](#configsreadmanyasync)
    -   [Parameters](#parameters-5)
-   [configsReadManySync](#configsreadmanysync)
    -   [Parameters](#parameters-6)

## ConfigReadOptions

Config read options type

### Parameters

-   `options` **(Partial&lt;[ConfigReadOptions](#configreadoptions)> | [undefined](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/undefined) | null)** The options to merge, (optional, default `null`)

### allowDirectories

True if directories can be read merging all files inside them

Type: [boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)

### rootPath

The root path to use. If unspecified, current directory is used.

Type: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)

### extensions

The file extensions that are parseable.

Type: [Object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), [boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)>

### default

The default options.

Type: Partial&lt;[ConfigReadOptions](#configreadoptions)>

## configReadSync

Reads a configuration file or directory synchronously.

### Parameters

-   `configPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the file or directory to load
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions.default`)

Returns **any** The loaded data

## configReadAsync

Reads a configuration file or directory asynchronously.

### Parameters

-   `configPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the file or directory to load
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions`)

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;any>** A promise that resolves the loaded data

## configsListAsync

Lists all configurations in a directory, asynchrounously.

### Parameters

-   `folderPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the folder that contains multiple configurations to list
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions`)

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[Array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>>** A promise that resolves a list of full paths

## configsListSync

Lists all configurations in a directory, synchrounously.

### Parameters

-   `folderPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the folder that contains multiple configurations to list
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions`)

Returns **[Array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** A list of all full paths of all configurations

## configsReadManyAsync

Reads all the configurations contained in a folder to a map object

### Parameters

-   `folderPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the folder that contains multiple configurations to load
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions`)

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[Object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), any>>** A promise that resolves a map of loaded configurations

## configsReadManySync

Reads all the configurations contained in a folder to a map object

### Parameters

-   `folderPath` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Path of the folder that contains multiple configurations to load
-   `options` **Partial&lt;[ConfigReadOptions](#configreadoptions)>** The options (optional, default `ConfigReadOptions`)

Returns **[Object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), any>** A map of loaded configurations
